--[[

Name: MusicStrem
Revision: $Revision: 24634 $
Date: $Date: 2007-01-11 03:28:12 -0500 (Thu, 11 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: Play Streaming Music in World of Warcraft.
Dependencies: Ace2

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 24634 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("MusicStream")

L:RegisterTranslations("enUS", function() return {
    ["Music Stream"] = true,
	["Plays Streaming Music"] = true,
	["Shows the Options Dropdown"] = true,
	["Stop"] = true,
	["Stop Music"] = true,
	["Prev"] = true,
	["Previous Channel"] = true,
	["Play"] = true,
	["Play Channel"] = true,
	["Next"] = true,
	["Next Channel"] = true,
	["Settings"] = true,
	["Change MusicStream Settings"] = true,
	["General Settings"] = true,
	["Channels"] = true,
	["Change Channel to Play"] = true,
	["Channel Settings"] = true,
    ["Disabled Modules"] = true,
	["Options"] = true,
	["Change Settings"] = true,
	["Advanced Settings"] = true,
	["Options you may not want to mess with"] = true,
	["Reset DB to Defaults"] = true,
	["Reset the Database back to Defaults"] = true,
	["Debugging"] = true,
	["Toggle Debugging for this Addon"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Music Stream"] = "음악 방송",
	["Plays Streaming Music"] = "음악 방송을 재생합니다.",
	["Shows the Options Dropdown"] = "옵션 메뉴를 표시합니다.",
	["Stop"] = "정지",
	["Stop Music"] = "음악을 정지합니다.",
	["Prev"] = "이전",
	["Previous Channel"] = "이전 채널",
	["Play"] = "재생",
	["Play Channel"] = "채널 재생",
	["Next"] = "다음",
	["Next Channel"] = "다음 채널",
	["Settings"] = "설정",
	["Change MusicStream Settings"] = "음악방송 설정을 변경합니다.",
	["General Settings"] = "일반적인 설정",
	["Channels"] = "채널",
	["Change Channel to Play"] = "재생할 채널을 변경합니다.",
	["Channel Settings"] = "채널 설정",
	["Disabled Modules"] = "사용하지 않는 모듈",
	["Options"] = "옵션",
	["Change Settings"] = "설정 변경",
	["Advanced Settings"] = "고급 설정",
--	["Options you may not want to mess with"] = true,
	["Reset DB to Defaults"] = "DB 초기화",
	["Reset the Database back to Defaults"] = "기본값으로 데이터베이스를 초기화 합니다.",
	["Debugging"] = "디버깅",
	["Toggle Debugging for this Addon"] = "애드온 디버깅을 켜거나 끕니다.",
} end)

--- ========================================================= ---
--- Register DB for Music Stream
--- ========================================================= ---
MusicStream = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0", "AceDebug-2.0", "AceEvent-2.0", "AceHook-2.1", "AceModuleCore-2.0")
MusicStream.dewdrop = AceLibrary("Dewdrop-2.0")

MusicStream:RegisterDB("MusicStreamDB")
MusicStream:SetModuleMixins("AceEvent-2.0", "AceHook-2.1",  "AceDebug-2.0")

MusicStream.defaultDB = {
}

local bluecolor = "|cFF0099CC"
local lbluecolor = "|cFF77BBFF"
local redcolor = "|cFFFF5522"
local greycolor = "|c77AAAAAA"

MusicStream.Options = {type = "group", handler = MusicStream, args = {
		header = {
			type = "header",
			name = bluecolor..L["Music Stream"].."  |c88888888"..Revision,
			icon = "Interface\\Addons\\MusicStream\\icon.tga",
			iconHeight = 28,
			iconWidth = 28,
			order = 1
		}, 
		stop = {
			name = L["Stop"],
			desc = L["Stop Music"],
			order = 100,
			type = "execute",
			func = function() MusicStream_Stop(); end,
		},
		prev = {
			name = L["Prev"],
			desc = L["Previous Channel"],
			order = 101,
			type = "execute",
			func = function() MusicStream_Prev(); end,
		},
		play = {
			name = L["Play"],
			desc = L["Play Channel"],
			order = 102,
			type = "execute",
			func = function() MusicStream_Play(); end,
		},
		next = {
			name = L["Next"],
			desc = L["Next Channel"],
			order = 103,
			type = "execute",
			func = function() MusicStream_Next(); end,
		},
		blank = {
			type = 'header',
			order = 105,
		},
		channels = {
			name = L["Channels"],
			desc = L["Change Channel to Play"],
			order = 110,
			type = 'group',
			args = {}
		},
		
		optionsheaderblank = {
			type = 'header',
			order = 199,
		},
		optionsheader = {
			type = "header",
			name = lbluecolor..L["Options"],
			icon = "Interface\\GossipFrame\\TrainerGossipIcon",
			order = 200
		}, 
		
		settingsheaderblank = {
			type = 'header',
			order = 299,
		},
		settingsheader = {
			type = "header",
			name = lbluecolor..L["Settings"],
			icon = "Interface\\GossipFrame\\BinderGossipIcon",
			order = 300
		}, 
		settings = {
			name = L["Change Settings"],
			desc = L["Change MusicStream Settings"],
			order = 301,
			type = 'group',
			args = {
				generalheader = {
					type = "header",
					name = lbluecolor..L["General Settings"],
					icon = "Interface\\GossipFrame\\BinderGossipIcon",
					order = 100
				}, 
				channelsheaderblank = {
					type = 'header',
					order = 199,
				},
				channelsheader = {
					type = "header",
					name = lbluecolor..L["Channel Settings"],
					icon = "Interface\\GossipFrame\\BinderGossipIcon",
					order = 200
				},
				advancedheaderblank = {
					type = 'header',
					order = 999,
				},
				advancedheader = {
					type = "header",
					name = lbluecolor..L["Advanced Settings"],
					icon = "Interface\\GossipFrame\\BinderGossipIcon",
					order = 1000
				},
				advancedsettings = {
					name = greycolor..L["Advanced Settings"],
					desc = greycolor..L["Options you may not want to mess with"],
					order = 1001,
					type = 'group',
					args = {
						header = {
							type = "header",
							name = lbluecolor..L["Advanced Settings"],
							icon = "Interface\\GossipFrame\\BinderGossipIcon",
							order = 1
						},
						blank = {
							type = 'header',
							order = 2,
						},
						reset = {
							name = redcolor..L["Reset DB to Defaults"],
							desc = greycolor..L["Reset the Database back to Defaults"],
							order = 200,
							type = "execute",
							confirm = true,
							func = function() MusicStream:ResetDB(); end,
						},
					},
				},
			},
		},
		
		options = {
			name = L["Options"],
			desc = L["Shows the Options Dropdown"],
			order = 300,
			type = "execute",
			func = function() MusicStream:OpenMenu(UIParent) end,
			guiHidden = true
		},
    }
}

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStream:OnInitialize()
	MusicStream:RegisterDefaults("profile", {
		debug = false,
	})
	
	self:RegisterEvent("Ace2_AddonDisabled")
	self:RegisterEvent("Ace2_AddonEnabled")
	self:RegisterEvent("AceEvent_FullyInitialized")
	
	self:RegisterEvent("Masterpiece_Mounted")
	self:RegisterEvent("Masterpiece_Dismounted")
	
	self:RegisterEvent("Masterpiece_InFlight_Start")
	self:RegisterEvent("Masterpiece_InFlight_Stop")
end

--- ========================================================= ---
--- On Full Initialize
--- ========================================================= ---

function MusicStream:AceEvent_FullyInitialized()
	self:SetDebugging(self.db.profile.debug)
	self:Ace2_AddonDisabled(self)
	self:Ace2_AddonEnabled(self)
end

--- ========================================================= ---
--- On Addon Disabled
--- ========================================================= ---

function MusicStream:Ace2_AddonDisabled(mod)
	self:Debug("Ace2_AddonDisabled - "..mod.name)
end

--- ========================================================= ---
--- On Addon Enabled
--- ========================================================= ---

function MusicStream:Ace2_AddonEnabled(mod)
	self:Debug("Ace2_AddonEnabled - "..mod.name)
end

--- ========================================================= ---
--- On Debug Enable
--- ========================================================= ---

function MusicStream:OnDebugEnable()
	self.db.profile.debug = true
	self:Debug("Debug - ON")
end	

--- ========================================================= ---
--- On Debug Enable
--- ========================================================= ---

function MusicStream:OnDebugDisable()
	self.db.profile.debug = false
	self:Debug("Debug - OFF")
end

--- ========================================================= ---
--- Register Chat Command
--- ========================================================= ---

MusicStream:RegisterChatCommand({"/musicstream"}, MusicStream.Options)

--- ========================================================= ---
--- Options Dropdown
--- ========================================================= ---

function MusicStream:OpenMenu(frame)
	self.dewdrop:Open(frame,
		'children', function(level, value)
				self.dewdrop:FeedAceOptionsTable(self.Options)
			end,
		'cursorX', true,
		'cursorY', true
	)
end

--- ========================================================= ---
--- Get Fu Options
--- ========================================================= ---

function MusicStream:GetFuOptions()
	MusicStream.Options.args.settings.args = {
		name = L["FuBar Options"],
        desc = L["A module to change FuBar Options."],
        type = "group",
        args = {
			spacing = {
				name = L["Button Spacing"],
				desc = L["Set Button Spacing"],
				type = 'range',
				min  = 0,
				max  = 10,
				step = 0.5,
				set  = function(size) MusicStreamFu:SetButtonSpacing(size) end,
				get  = function() return MusicStreamFu:GetButtonSpacing() end,
			},
			visibility = {
				type = 'group',
				name = L["Button Visibility"],
				desc = L["Toggle Button Visibility"],
				args = {
				}
			},
		},
	}
end

--- ========================================================= ---
--- ResetDB
--- ========================================================= ---

function MusicStream:ResetDB()
	for name, module in self:IterateModules() do
		if type(module.ResetDB) == "function" then
			module:ResetDB();
			self:Debug(name.." successfully reset.")
		end
	end
end

--- ========================================================= ---
--- Play
--- ========================================================= ---

function MusicStream_Play()
	MusicStreamChannels:GetMusic();
	
	MSNowPlaying:SetText(ChannelNowLabel);
	
	PlayMusic(ChannelNowAddress)
end

--- ========================================================= ---
--- Stop
--- ========================================================= ---

function MusicStream_Stop()
	MSNowPlaying:SetText("Standyby");
	
	StopMusic();
end

--- ========================================================= ---
--- Next
--- ========================================================= ---

function MusicStream_Next()
	MusicStreamChannels:GetMusic();
	
	Channel = ChannelNext;
	MusicStream_Play();
end

--- ========================================================= ---
--- Prev
--- ========================================================= ---

function MusicStream_Prev()
	MusicStreamChannels:GetMusic();
	
	Channel = ChannelPrev;
	MusicStream_Play();
end

-- Ignore Below, in testing for something new

--- ========================================================= ---
--- Mounted Event
--- ========================================================= ---

function MusicStream:Masterpiece_Mounted(buff)
	self:Debug("Player Mounted ("..buff..")")
end

--- ========================================================= ---
--- Dismounted Event
--- ========================================================= ---

function MusicStream:Masterpiece_Dismounted(buff)
	self:Debug("Player Dismounted ("..buff..")")
end

--- ========================================================= ---
--- Taxi Event Start
--- ========================================================= ---

function MusicStream:Masterpiece_InFlight_Start(source, dest)
	self:Debug("Taxi Started ("..source.." -> "..dest..")")
end

--- ========================================================= ---
--- Taxi Event Stop
--- ========================================================= ---

function MusicStream:Masterpiece_InFlight_Stop()
	self:Debug("Taxi Stopped")
end