﻿--[[

Name: MusicStrem Channels
Revision: $Revision: 24634 $
Date: $Date: 2007-01-11 03:28:12 -0500 (Thu, 11 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: A module to control the streaming radio channels.
Dependencies: Ace2, MusicStream

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 24634 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("Channels")

L:RegisterTranslations("enUS", function() return {
    ["Channels"] = true,
    ["A module containing the channels to play."] = true,
	
	["Pop"] = true,
	["Play Pop Channels"] = true,
	["Rap"] = true,
	["Play Rap Channels"] = true,
	["Rock"] = true,
	["Play Rock Channels"] = true,
	["Country"] = true,
	["Play Country Channels"] = true,
	["90s"] = true,
	["Play 90s Channels"] = true,
	["80s"] = true,
	["Play 80s Channels"] = true,
	["70s"] = true,
	["Play 70s Channels"] = true,
	["Techno"] = true,
	["Play Techno Channels"] = true,
	["Jazz"] = true,
	["Play Jazz Channels"] = true,
	["Classical"] = true,
	["Play Classical Channels"] = true,
	["Comedy"] = true,
	["Play Comedy Channels"] = true,
	["Talk"] = true,
	["Play Talk Channels"] = true,
	
} end)

L:RegisterTranslations("koKR", function() return {
	["Channels"] = "채널목록",
	["A module containing the channels to play."] = "재생할 채널을 포함한 모듈입니다.",

	["Pop"] = "팝",
	["Play Pop Channels"] = "팝 방송 채널",
	["Rap"] = "랩",
	["Play Rap Channels"] = "랩 방송 채널",
	["Rock"] = "락",
	["Play Rock Channels"] = "락 방송 채널",
	["Country"] = "컨트리",
	["Play Country Channels"] = "컨트리 재생 채널",
	["90s"] = "90년대",
	["Play 90s Channels"] = "90년대 방송 채널",
	["80s"] = "80년대",
	["Play 80s Channels"] = "80년대 재생 채널",
	["70s"] = "70년대",
	["Play 70s Channels"] = "70년대 방송 채널",
	["Techno"] = "테크노",
	["Play Techno Channels"] = "테크노 방송 채널",
	["Jazz"] = "재즈",
	["Play Jazz Channels"] = "재즈 방송 채널",
	["Classical"] = "클래식",
	["Play Classical Channels"] = "클래식 방송 채널",
	["Comedy"] = "코메디",
	["Play Comedy Channels"] = "코메디 방송 채널",
	["Talk"] = "토크",
	["Play Talk Channels"] = "토크 방송 채널",
} end)

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

MusicStreamChannels = MusicStream:NewModule("Channels")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStreamChannels:OnInitialize()
	self.db = MusicStream:AcquireDBNamespace("Channels")
	
	MusicStreamChannels.defaultDB = {
		channels = {
			[1] = {
				title = "977 The Hitz Channel",
				address = "http://scfire-dll0l-2.stream.aol.com:80/stream/1074",
				genre = "Pop",
				skip = false,
				removed = false,
			},
			[2] = {
				title = "Hitz Radio",
				address = "http://scfire-nyk0l-1.stream.aol.com:80/stream/1038",
				genre = "Pop",
				skip = false,
				removed = false,
			},
			[3] = {
				title = "Sky FM - Top Hits Music",
				address = "http://64.236.98.50:80/stream/1014",
				genre = "Pop",
				skip = false,
				removed = false,
			},
			[4] = {
				title = "HoT 108 Jamz",
				address = "http://scfire-nyk0l-1.stream.aol.com:80/stream/1071",
				genre = "Rap",
				skip = false,
				removed = false,				
			},
			[5] = {
				title = "1.FM - Jamz",
				address = "http://64.71.145.130:8055",
				genre = "Rap",
				skip = false,
				removed = false,				
			},
			[6] = {
				title = "Powerhitz",
				address = "http://scfire-nyk0l-1.stream.aol.com:80/stream/1044",
				genre = "Rap",
				skip = false,
				removed = false,				
			},
			[7] = {
				title = "The Edge",
				address = "http://67.43.161.248:6001",
				genre = "Rock",
				skip = false,
				removed = false,				
			},
			[8] = {
				title = "ChroniX Radio",
				address = "http://scfire-dll0l-1.stream.aol.com:80/stream/1039",
				genre = "Rock",
				skip = false,
				removed = false,				
			},
			[9] = {
				title = "Idobi Radio",
				address = "http://213.251.129.50:8080",
				genre = "Rock",
				skip = false,
				removed = false,					
			},
			[10] = {
				title = "Kickin` Country",
				address = "http://scfire-dll0l-1.stream.aol.com:80/stream/1075",
				genre = "Country",
				skip = false,
				removed = false,				
			},
			[11] = {
				title = "1.FM - Country",
				address = "http://64.62.194.11:8020",
				genre = "Country",
				skip = false,
				removed = false,			
			},
			[12] = {
				title = "Sky FM - Country",
				address = "http://scfire-nyk0l-2.stream.aol.com:80/stream/1019",
				genre = "Country",
				skip = false,
				removed = false,				
			},
			[13] = {
				title = "1.FM - The 90's",
				address = "http://64.71.145.130:8065",
				genre = "90s",
				skip = false,
				removed = false,				
			},
			[14] = {
				title = "977 The 80s Channel",
				address = "http://scfire-dll0l-2.stream.aol.com:80/stream/1040",
				genre = "80s",
				skip = false,
				removed = false,			
			},
			[15] = {
				title = "Sky FM - All Hit 70s",
				address = "http://64.236.34.97:80/stream/1076",
				genre = "70s",
				skip = false,
				removed = false,				
			},
			[16] = {
				title = "DIGITALLY IMPORTED - European Trance",
				address = "http://scfire-dll0l-1.stream.aol.com:80/stream/1003",
				genre = "Techno",
				skip = false,
				removed = false,			
			},
			[17] = {
				title = "Sky FM - Absolutely Smooth Jazz",
				address = "http://scfire-ntc0l-1.stream.aol.com:80/stream/1005",
				genre = "Jazz",
				skip = false,
				removed = false,				
			},
			[18] = {
				title = "Sky FM - Mostly Classical",
				address = "http://scfire-ntc0l-2.stream.aol.com:80/stream/1006",
				genre = "Classical",
				skip = false,
				removed = false,				
			},
			[19] = {
				title = "THE DEFCON COMEDY NETWORK ",
				address = "http://209.96.240.30:9874",
				genre = "Comedy",
				skip = false,
				removed = false,			
			},
			[20] = {
				title = "Sporting News Radio",
				address = "http://64.236.34.97:80/stream/1057",
				genre = "Talk",
				skip = false,
				removed = false,			
			},
		}
	}
	
	MusicStream:RegisterDefaults("Channels", "profile", opts or MusicStreamChannels.defaultDB or {})
	
	MusicStream.Options.args.channels.args = {
		Pop = {
               name = L["Pop"],
               desc = L["Play Pop Channels"],
               type = "group",
               order = 100,
               args = {
               },
		},
		Rap = {
               name = L["Rap"],
               desc = L["Play Rap Channels"],
               type = "group",
               order = 100,
               args = {
                },
		},
		Rock = {
               name = L["Rock"],
               desc = L["Play Rock Channels"],
               type = "group",
               order = 100,
               args = {
               },
			},
		Country = {
               name = L["Country"],
               desc = L["Play Country Channels"],
               type = "group",
               order = 100,
               args = {
               },
		},
			Ninetys = {
               name = L["90s"],
               desc = L["Play 90s Channels"],
               type = "group",
               order = 100,
               args = {
               },
		},
		Eightys = {
               name = L["80s"],
               desc = L["Play 80s Channels"],
                type = "group",
               order = 100,
               args = {
               },
		},
		Seventys = {
               name = L["70s"],
               desc = L["Play 70s Channels"],
               type = "group",
               order = 100,
                args = {
               },
		},
		Techno = {
               name = L["Techno"],
               desc = L["Play Techno Channels"],
               type = "group",
               order = 100,
               args = {
               },
		},
		Jazz = {
               name = L["Jazz"],
                desc = L["Play Jazz Channels"],
               type = "group",
               order = 100,
               args = {
               },
		},
		Classical = {
               name = L["Classical"],
               desc = L["Play Classical Channels"],
               type = "group",
               order = 100,
                args = {
               },
		},
		Comedy = {
               name = L["Comedy"],
               desc = L["Play Comedy Channels"],
               type = "group",
               order = 100,
               args = {
               },
		},
		Talk = {
               name = L["Talk"],
               desc = L["Play Talk Channels"],
               type = "group",
               order = 100,
               args = {
               },
		}
	}
	
	local bluecolor = "|cFF0099CC"
	local lbluecolor = "|cFF77BBFF"
	
	MusicStream.Options.args.channels.args.Channels = {
		type = "header",
		name = bluecolor..L["Channels"].."  |c88888888"..Revision,
		icon = "Interface\\Addons\\MusicStream\\icon.tga",
		iconHeight = 14,
		iconWidth = 14,
		order = 1
	}
	
	MusicStream.Options.args.channels.args.ChannelsBlank = {
       	type = "header",
		order = 2,
	}
	
	MusicStreamChannels:BuildChannels();
	
	MusicStreamChannels:GetMusic();
end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function MusicStreamChannels:ResetDB()
	copyTable(self.db.profile, MusicStreamChannels.defaultDB)
	MusicStreamChannels:BuildChannels();
	MusicStreamChannels:GetMusic();
end

--- ========================================================= ---
--- Build Channels
--- ========================================================= ---

function MusicStreamChannels:BuildChannels()
	for i,data in ipairs(self.db.profile.channels) do
		genre = self.db.profile.channels[i].genre;
		
		if (genre == "70s") then
			genre = "Seventys";
		end
		if (genre == "80s") then
			genre = "Eightys";
		end
		if (genre == "90s") then
			genre = "Ninetys";
		end
		
		MusicStream.Options.args.channels.args[genre].args = { }
	end
	
	for i,data in ipairs(self.db.profile.channels) do
		if not self.db.profile.channels[i].removed then
			genre = self.db.profile.channels[i].genre;
		
			if (genre == "70s") then
				genre = "Seventys";
			end
			if (genre == "80s") then
				genre = "Eightys";
			end
			if (genre == "90s") then
				genre = "Ninetys";
			end
		
			TotalChannels = i;

			MusicStream.Options.args.channels.args[genre].args[i] = {
				name = self.db.profile.channels[i].title,
				desc = self.db.profile.channels[i].address,
				order = i,
				type = 'execute',
				func = function() Channel = i; MusicStream_Play(); end,
			}
		end
	end
end

--- ========================================================= ---
--- Get Channels
--- ========================================================= ---

function MusicStreamChannels:GetMusic()
	
	if not(Channel) then
		Channel = 1;
	end
	
	if Channel > TotalChannels then
		Channel = 1;
	end
	
	ChannelNowLabel = (self.db.profile.channels[Channel].title);
	ChannelNowAddress = (self.db.profile.channels[Channel].address);
	
	tchannel = Channel;
	for i=#self.db.profile.channels,1,-1 do
		if (tchannel == i) then
			tchannel = (tchannel - 1);
			if (tchannel < 1) then
				for i=#self.db.profile.channels,1,-1 do
					if not(self.db.profile.channels[i].skip) then
						MusicStreamChannels:SetPrevChannel(i);
						break;
					end
					end
			end
			if (tchannel > 0) then
				if not(self.db.profile.channels[tchannel].skip) then
					MusicStreamChannels:SetPrevChannel(tchannel);
					break;
				end
			end
		end
	end
	
	tchannel = Channel;
	for i, data in ipairs(self.db.profile.channels) do
		if (tchannel == i) then
			tchannel = (tchannel + 1);
			if (tchannel > TotalChannels) then
				for i, data in ipairs(self.db.profile.channels) do
						if not(self.db.profile.channels[i].skip) then
						MusicStreamChannels:SetNextChannel(i);
						break;
					end
				end
			end
			if (tchannel < (TotalChannels + 1)) then
				if not(self.db.profile.channels[tchannel].skip) then
					MusicStreamChannels:SetNextChannel(tchannel);
						break;
				end
			end
		end
	end
	
end

--- ========================================================= ---
--- Set Next Channel
--- ========================================================= ---

function MusicStreamChannels:SetNextChannel(channel)
	ChannelNext = channel;
	ChannelNextLabel = (self.db.profile.channels[channel].title);
	ChannelNextAddress = (self.db.profile.channels[channel].address);
end

--- ========================================================= ---
--- Set Prev Channel
--- ========================================================= ---

function MusicStreamChannels:SetPrevChannel(channel)
	ChannelPrev = channel;
	ChannelPrevLabel = (self.db.profile.channels[channel].title);
	ChannelPrevAddress = (self.db.profile.channels[channel].address);
end