﻿--[[

Name: MusicStrem Chat Play
Revision: $Revision: 24634 $
Date: $Date: 2007-01-11 03:28:12 -0500 (Thu, 11 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: A module to allow you to click and play a broadcasted channel from another player. (UNDER DEV)
Dependencies: Ace2, MusicStream

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 24634 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("ChatPlay")

L:RegisterTranslations("enUS", function() return {
    ["Chat Play"] = true,
    ["(UNDER DEV)"] = true,
	
	["Toggle"] = true,
    ["Toggle the Module On and Off"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Chat Play"] = "대화 재생",
	["(UNDER DEV)"] = "(개발 중)",

	["Toggle"] = "사용",
	["Toggle the Module On and Off"] = "기능을 사용하거나 사용하지 않습니다.",
} end)

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

MusicStreamChatPlay = MusicStream:NewModule("ChatPlay")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStreamChatPlay:OnInitialize()
    self.db = MusicStream:AcquireDBNamespace("ChatPlay")
    
	MusicStreamChatPlay.defaultDB = {
        on = true,
    }
	
	MusicStream:RegisterDefaults("ChatPlay", "profile", opts or MusicStreamChatPlay.defaultDB or {})
	
    MusicStream:ToggleModuleActive("ChatPlay", self.db.profile.on)
    
	local bluecolor = "|cFF0099CC"
	local lbluecolor = "|cFF77BBFF"
	
    MusicStream.Options.args.settings.args.ChatPlay = {
        name = L["Chat Play"],
        desc = L["(UNDER DEV)"],
		order = 103,
        type = "group",
        args = {
			header = {
				type = "header",
				name = bluecolor..L["Chat Play"].."  |c88888888"..Revision,
				icon = "Interface\\Addons\\MusicStream\\icon.tga",
				iconHeight = 14,
				iconWidth = 14,
				order = 1
            },
			blank = {
       			type = "header",
				order = 2,
			},
             toggle = {
                name = L["Toggle"],
                desc = L["Toggle the Module On and Off"],
				order = 200,
                type = "toggle",
                get = function() return self.db.profile.on end,
                set = function() self.db.profile.on = MusicStream:ToggleModuleActive("ChatPlay") end
            }
        }
    }
end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function MusicStreamChatPlay:ResetDB()
	copyTable(self.db.profile, MusicStreamChatPlay.defaultDB)
end