﻿--[[

Name: MusicStrem Play Custom
Revision: $Revision: 24634 $
Date: $Date: 2007-01-11 03:28:12 -0500 (Thu, 11 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: A module to auto play the last channel you were playing on last session.
Dependencies: Ace2, MusicStream

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 24634 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("PlayCustom")

L:RegisterTranslations("enUS", function() return {
    ["Play Custom"] = true,
    ["Play Custom Channel"] = true,

} end)

L:RegisterTranslations("koKR", function() return {
	["Play Custom"] = "사용자 지정 재생",
	["Play Custom Channel"] = "사용자 지정 채널을 재생합니다.",
} end)

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

MusicStreamPlayCustom = MusicStream:NewModule("PlayCustom")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStreamPlayCustom:OnInitialize()
    self.db = MusicStream:AcquireDBNamespace("PlayCustom")

	MusicStreamPlayCustom.defaultDB = {
    }
	
	MusicStream:RegisterDefaults("PlayCustom", "profile", opts or MusicStreamPlayCustom.defaultDB or {})
	
	if (self.db.profile.on == true) then
		if (self.db.profile.channel) then
			Channel = self.db.profile.channel;
		end
	end
	
    MusicStream.Options.args.PlayCustom = {
      	name = L["Play Custom"],
        desc = L["Play Custom Channel"],
		order = 201,
        type = "text",
        usage = "<string>",
        get = false,
		set = function(name) self:PlayCustomChannel(name) end
    }
	
end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function MusicStreamPlayCustom:ResetDB()
	copyTable(self.db.profile, MusicStreamPlayCustom.defaultDB)
end

--- ========================================================= ---
--- Play Custom Chanel
--- ========================================================= ---

function MusicStreamPlayCustom:PlayCustomChannel(name)
		MusicStreamChannelAlert:ChannelAlert("Playing Input - "..name.." -");
		PlayMusic(name);
		
		ChannelNowLabel = "Custom Channel";
		ChannelNowAddress = name;
end