﻿--[[

Name: MusicStrem Remove Channels
Revision: $Revision: 23844 $
Date: $Date: 2007-01-07 03:01:22 -0500 (Sun, 07 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: A module to select channels to Remove.
Dependencies: Ace2, MusicStream

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 23844 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("RemoveChannel")

L:RegisterTranslations("enUS", function() return {
    ["Remove Channels"] = true,
    ["Remove a Channel from the Database"] = true,
	
	["Pop"] = true,
	["Remove Pop Channels"] = true,
	["Rap"] = true,
	["Remove Rap Channels"] = true,
	["Rock"] = true,
	["Remove Rock Channels"] = true,
	["Country"] = true,
	["Remove Country Channels"] = true,
	["90s"] = true,
	["Remove 90s Channels"] = true,
	["80s"] = true,
	["Remove 80s Channels"] = true,
	["70s"] = true,
	["Remove 70s Channels"] = true,
	["Techno"] = true,
	["Remove Techno Channels"] = true,
	["Jazz"] = true,
	["Remove Jazz Channels"] = true,
	["Classical"] = true,
	["Remove Classical Channels"] = true,
	["Comedy"] = true,
	["Remove Comedy Channels"] = true,
	["Talk"] = true,
	["Remove Talk Channels"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Remove Channels"] = "채널 삭제",
	["Remove a Channel from the Database"] = "데이터베이스에서 채널을 삭제합니다.",

	["Pop"] = "팝",
	["Remove Pop Channels"] = "팝 채널을 삭제합니다.",
	["Rap"] = "랩",
	["Remove Rap Channels"] = "랩 채널을 삭제합니다.",
	["Rock"] = "락",
	["Remove Rock Channels"] = "락 채널을 삭제합니다.",
	["Country"] = "컨트리",
	["Remove Country Channels"] = "컨트리 채널을 삭제합니다.",
	["90s"] = "90년대",
	["Remove 90s Channels"] = "90년대 채널을 삭제합니다.",
	["80s"] = "80년대",
	["Remove 80s Channels"] = "80년대 채널을 삭제합니다.",
	["70s"] = "70년대",
	["Remove 70s Channels"] = "70년대 채널을 삭제합니다.",
	["Techno"] = "테크노",
	["Remove Techno Channels"] = "테크노 채널을 삭제합니다.",
	["Jazz"] = "재즈",
	["Remove Jazz Channels"] = "재즈 채널을 삭제합니다.",
	["Classical"] = "클래식",
	["Remove Classical Channels"] = "클래식 채널을 삭제합니다.",
	["Comedy"] = "코미디",
	["Remove Comedy Channels"] = "코미디 채널을 삭제합니다.",
	["Talk"] = "토크",
	["Remove Talk Channels"] = "토크 채널을 삭제합니다.",
} end)

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

MusicStreamRemoveChannel = MusicStream:NewModule("RemoveChannel")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStreamRemoveChannel:OnInitialize()
    self.db = MusicStream:AcquireDBNamespace("RemoveChannel")
	
	MusicStreamRemoveChannel.defaultDB = {
    }
	
	MusicStream:RegisterDefaults("RemoveChannel", "profile", opts or MusicStreamRemoveChannel.defaultDB or {})
	
	MSRemoveChannel = self.db.profile.on;
	    
	local bluecolor = "|cFF0099CC"
	local lbluecolor = "|cFF77BBFF"
	
    MusicStream.Options.args.settings.args.RemoveChannel = {
        name = L["Remove Channels"],
        desc = L["Remove a Channel from the Database"],
		order = 203,
        type = "group",
        args = {
			header = {
				type = "header",
				name = bluecolor..L["Remove Channels"].."  |c88888888"..Revision,
				icon = "Interface\\Addons\\MusicStream\\icon.tga",
				iconHeight = 14,
				iconWidth = 14,
				order = 1
            },
			blank = {
       			type = "header",
				order = 2,
			},
			Pop = {
                name = L["Pop"],
                desc = L["Remove Pop Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Rap = {
                name = L["Rap"],
                desc = L["Remove Rap Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Rock = {
                name = L["Rock"],
                desc = L["Remove Rock Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Country = {
                name = L["Country"],
                desc = L["Remove Country Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Ninetys = {
                name = L["90s"],
                desc = L["Remove 90s Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Eightys = {
                name = L["80s"],
                desc = L["Remove 80s Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Seventys = {
                name = L["70s"],
                desc = L["Remove 70s Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Techno = {
                name = L["Techno"],
                desc = L["Remove Techno Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Jazz = {
                name = L["Jazz"],
                desc = L["Remove Jazz Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Classical = {
                name = L["Classical"],
                desc = L["Remove Classical Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Comedy = {
                name = L["Comedy"],
                desc = L["Remove Comedy Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
			Talk = {
                name = L["Talk"],
                desc = L["Remove Talk Channels"],
                type = "group",
                order = 100,
                args = {
                },
			},
        }
    }
	
	MusicStreamRemoveChannel:BuildRemoved();
	
end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function MusicStreamRemoveChannel:ResetDB()
	copyTable(self.db.profile, MusicStreamRemoveChannel.defaultDB)
	MusicStreamRemoveChannel:BuildRemoved();
end

--- ========================================================= ---
--- Build Remove Channel List
--- ========================================================= ---

function MusicStreamRemoveChannel:BuildRemoved()
	for i,data in ipairs(MusicStreamChannels.db.profile.channels) do
		genre = MusicStreamChannels.db.profile.channels[i].genre;
		
		if (genre == "70s") then
			genre = "Seventys";
		end
		if (genre == "80s") then
			genre = "Eightys";
		end
		if (genre == "90s") then
			genre = "Ninetys";
		end
		
		MusicStream.Options.args.settings.args.RemoveChannel.args[genre].args = { }
	end
	
	for i,data in ipairs(MusicStreamChannels.db.profile.channels) do
		if not MusicStreamChannels.db.profile.channels[i].removed then
			genre = MusicStreamChannels.db.profile.channels[i].genre;
			
			if (genre == "70s") then
				genre = "Seventys";
			end
			if (genre == "80s") then
				genre = "Eightys";
			end
			if (genre == "90s") then
				genre = "Ninetys";
			end
		
			TotalChannels = i;

			MusicStream.Options.args.settings.args.RemoveChannel.args[genre].args[i] = {
				name = MusicStreamChannels.db.profile.channels[i].title,
				desc = MusicStreamChannels.db.profile.channels[i].address,
				order = i,
				type = 'execute',
				func = function() RChannel = data; MusicStreamRemoveChannel:RemoveChannel(); end,
			}
		end
	end
end

--- ========================================================= ---
--- Remove Channel
--- ========================================================= ---

function MusicStreamRemoveChannel:RemoveChannel()
	for i,data in pairs(MusicStreamChannels.db.profile.channels) do
		if RChannel == data then
			if ChannelNowLabel == MusicStreamChannels.db.profile.channels[i].title then
				Channel = ChannelNext;
			end
			if MusicStreamChannels.db.profile.channels[i].removed == false then
				MusicStream:Debug("Removing Channel - "..MusicStreamChannels.db.profile.channels[i].title)
				MusicStreamChannels.db.profile.channels[i].removed = true;
				MusicStreamChannels.db.profile.channels[i].skip = true;
			else
				MusicStream:Debug("Removing Channel - "..MusicStreamChannels.db.profile.channels[i].title)
				table.remove(MusicStreamChannels.db.profile.channels, i)
			end
		end
	end
	
	if MusicStreamSkipChannel then
		MusicStreamSkipChannel:BuildSkipped();
	end
	
	if MusicStreamRemoveChannel then
		MusicStreamRemoveChannel:BuildRemoved();
	end
	
	MusicStreamChannels:BuildChannels();
	MusicStreamChannels:GetMusic();
end